/***************************************************************************
 *                   pcm2wav.c  -   Padova, Gennaio 1997                   *
 *                             Roberto Ferro                               *
 *                                                                         *
 * Converte il file "testo.pcm" nel file "testo.wav". A questo punto si    *
 * pu utilizzare il wave-player fornito con la scheda sonora.             *
 *                                                                         *
 * Per ulteriori informazioni contattare:                                  *
 *                                                                         *
 * Ferro Roberto - via Orsera 6, 30126 Lido Venezia                        *
 *                 tel. 041-5267626                                        *
 *                 E-mail: cdhb@ux1.unipd.it                               *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>

typedef struct {
    char id1[4];
    unsigned long FileSize;
    char id2[12];
    unsigned int FormatCategory;
    unsigned int NumChannel;
    unsigned long SamplingRate;
    unsigned long AvgBytePerSec;
    unsigned int BlockAlign;

    unsigned int BitsPerSample;

    char id3[4];

    unsigned long NumSamples;

} WAVE_HEADER;

unsigned long filesize(FILE *stream)
{
   long curpos, length;

   curpos = ftell(stream);
   fseek(stream, 0L, SEEK_END);
   length = ftell(stream);
   fseek(stream, curpos, SEEK_SET);
   return (unsigned long)length;
}

int main()
{
  FILE *fin = fopen("testo.pcm","rb");
  FILE *fout = fopen("testo.wav","wb");
  int n;
  char buff[1024];
  WAVE_HEADER header;

  if (fin==NULL || fout==NULL) {
    printf("errore apertura file su disco");
    return 1;
  }

  header.id1[0] = 'R'; header.id1[1] = 'I';
  header.id1[2] = 'F'; header.id1[3] = 'F';
  header.FileSize = filesize(fin) - 8;
  header.id2[0] = 'W'; header.id2[1] = 'A';
  header.id2[2] = 'V'; header.id2[3] = 'E';
  header.id2[4] = 'f'; header.id2[5] = 'm';
  header.id2[6] = 't'; header.id2[7] = 0x20;
  header.id2[8] = 0x10; header.id2[9] = 0;
  header.id2[10] = 0; header.id2[11] = 0;

  header.FormatCategory = 0x0001; // PCM
  header.NumChannel = 1;	  // mono
  header.SamplingRate = 10000;
  header.AvgBytePerSec = 20000;	  // NumChannel*SamplingRate*BitsPerSample/8
  header.BlockAlign = 2;	  // NumChannel*BitsPerSample/8

  header.BitsPerSample = 16;

  header.id3[0] = 'd'; header.id3[1] = 'a';
  header.id3[2] = 't'; header.id3[3] = 'a';

  header.NumSamples =  filesize(fin) - 44;

  fwrite(&header,sizeof(WAVE_HEADER),1,fout);

  while ((n = fread(buff,1,1024,fin)) == 1024)
    fwrite(buff,1,n,fout);

  fwrite(buff,1,n,fout);

  fclose(fin);
  fclose(fout);
  return 0;
}